import 'package:ali_rtc_fluttify/ali_rtc_fluttify.dart';
import 'package:flutter/material.dart';
import 'package:permission_handler/permission_handler.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();

  await [Permission.camera, Permission.microphone].request();

  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(title: const Text('Plugin example app')),
        body: AliRenderView(
          onViewCreated: (controller) async {
            final canvas = await AliVideoCanvas.create();
            await canvas.setView(controller);

            final engine = await AliRtcEngine.getInstance();
            await engine.setLocalViewConfig(canvas, Track.TrackCamera);
            await engine.startPreview();
          },
        ),
      ),
    );
  }
}
