part of ali_rtc_fluttify;

class AliRenderView extends StatelessWidget {
  const AliRenderView({
    Key key,
    this.onViewCreated,
  }) : super(key: key);

  final ValueChanged<AliRenderViewController> onViewCreated;

  @override
  Widget build(BuildContext context) {
    if (Platform.isAndroid) {
      return org_webrtc_sdk_SophonSurfaceView_Android(
        onViewCreated: (controller) async {
          await controller.setZOrderOnTop(true);
          await controller.setZOrderMediaOverlay(true);
          if (onViewCreated != null) {
            onViewCreated(AliRenderViewController.android(controller));
          }
        },
      );
    } else if (Platform.isIOS) {
      return ios.AliRenderView_iOS(
        onViewCreated: (controller) async {
          if (onViewCreated != null) {
            onViewCreated(AliRenderViewController.ios(controller));
          }
        },
      );
    } else {
      return Center(child: Text('未实现的平台'));
    }
  }
}

class AliRenderViewController {
  AliRenderViewController.android(this._androidModel) : this._iosModel = null;

  AliRenderViewController.ios(this._iosModel) : this._androidModel = null;

  final org_webrtc_sdk_SophonSurfaceView _androidModel;
  org_webrtc_sdk_SophonSurfaceView get androidView => _androidModel;

  final ios.AliRenderView _iosModel;
  ios.AliRenderView get iosView => _iosModel;
}
