part of ali_rtc_fluttify;

class AliVideoCanvas {
  static Future<AliVideoCanvas> create() async {
    final result = AliVideoCanvas._();
    await platform(
      android: (pool) async {
        result._androidCanvas =
            await com_alivc_rtc_AliRtcEngine_AliVideoCanvas.create__();
      },
      ios: (pool) async {
        result._iosCanvas = await ios.AliVideoCanvas.create__();
      },
    );
    return result;
  }

  AliVideoCanvas._();

  com_alivc_rtc_AliRtcEngine_AliVideoCanvas _androidCanvas;
  ios.AliVideoCanvas _iosCanvas;

  Future<void> setView(AliRenderViewController view) async {
    return platform(
      android: (pool) async {
        await _androidCanvas.set_view(view.androidView);
      },
      ios: (pool) async {
        await _iosCanvas.set_view(view.iosView);
      },
    );
  }

  Future<void> setRenderMode(RenderMode mode) async {
    return platform(
      android: (pool) async {
        await _androidCanvas.set_renderMode(
          com_alivc_rtc_AliRtcEngine_AliRtcRenderMode.values[mode.index],
        );
      },
      ios: (pool) async {
        await _iosCanvas.set_renderMode(
          ios.AliRtcRenderMode.values[mode.index],
        );
      },
    );
  }

  Future<void> setMirrorMode(MirrorMode mode) async {
    return platform(
      android: (pool) async {
        await _androidCanvas.set_mirrorMode(
          com_alivc_rtc_AliRtcEngine_AliRtcRenderMirrorMode.values[mode.index],
        );
      },
      ios: (pool) async {
        await _iosCanvas.set_mirrorMode(
          ios.AliRtcRenderMirrorMode.values[mode.index],
        );
      },
    );
  }
}
