part of ali_rtc_fluttify;

class AuthInfo {
  /// 频道ID。1~64位，支持大小写字母、数字、下划线（_）、中划线（-）。
  String channel;

  /// 应用ID，在控制台应用管理页面创建和查看。
  String appid;

  /// 随机码。需要加上前缀AK-，由字母[a-zA-Z]和数字[0-9]组成，不包含特殊字符，最大64字节。例如：AK-2b9be4b25c2d38c409c376ffd2372be1。
  String nonce;

  /// 用户ID。1~64位，支持大小写字母、数字、下划线（_）、中划线（-）。
  String user_id;

  /// 频道鉴权令牌，计算方法：token = sha256(appId + appKey + channelId + userId + nonce + timestamp)。
  String token;

  /// 频道过期时间戳。代表令牌有效时间为当前时间+所选择小时数。
  int timestamp;

  /// 服务地址，该参数是数组类型，当前请使用：["https://rgslb.rtc.aliyuncs.com"]，请您通过业务服务器下发到客户端SDK，不建议您将该地址固化在客户端代码。
  List<String> gslb;

  Future<com_alivc_rtc_AliRtcAuthInfo> toAndroidModel() async {
    final result = await com_alivc_rtc_AliRtcAuthInfo.create__();

    if (channel != null) await result.setConferenceId(channel);
    if (appid != null) await result.setAppid(appid);
    if (nonce != null) await result.setNonce(nonce);
    if (user_id != null) await result.setUserId(user_id);
    if (token != null) await result.setToken(token);
    if (timestamp != null) await result.setTimestamp(timestamp);
    if (gslb != null) await result.setGslb(gslb);

    return result;
  }

  Future<ios.AliRtcAuthInfo> toIOSModel() async {
    final result = await ios.AliRtcAuthInfo.create__();

    if (channel != null) await result.set_channel(channel);
    if (appid != null) await result.set_appid(appid);
    if (nonce != null) await result.set_nonce(nonce);
    if (user_id != null) await result.set_user_id(user_id);
    if (token != null) await result.set_token(token);
    if (timestamp != null) await result.set_timestamp(timestamp);
    if (gslb != null) await result.set_gslb(gslb);

    return result;
  }
}
