part of ali_rtc_fluttify;

class _AndroidEventDelegate extends com_alivc_rtc_AliRtcEngineEventListener
    with _Callbacks {
  @override
  Future<void> onPublishResult(int result, String publishId) async {
    if (_onPublishResult != null) {
      _onPublishResult(result);
    }
  }

  @override
  Future<void> onUnpublishResult(int result) async {
    if (_onUnpublishResult != null) {
      _onUnpublishResult(result);
    }
  }
}

class _AndroidNotifyDelegate extends com_alivc_rtc_AliRtcEngineNotify
    with _Callbacks {
  // @override
  // Future<void> onRemoteUserUnPublish(
  //   com_alivc_rtc_AliRtcEngine rtcEngine,
  //   String userId,
  // ) async {
  //   if (_onRemoteUserUnPublish != null) {
  //     _onRemoteUserUnPublish(userId);
  //   }
  // }

  @override
  Future<void> onRemoteUserOnLineNotify(String uid) async {
    if (_onRemoteUserOnLineNotify != null) {
      _onRemoteUserOnLineNotify(uid);
    }
  }

  @override
  Future<void> onRemoteUserOffLineNotify(String uid) async {
    if (_onRemoteUserOffLineNotify != null) {
      _onRemoteUserOffLineNotify(uid);
    }
  }
}

class _IOSDelegate extends NSObject with ios.AliRtcEngineDelegate, _Callbacks {
  @override
  Future<void> onPublishResult_isPublished(
    int result,
    bool isPublished,
  ) async {
    if (isPublished) {
      if (_onPublishResult != null) {
        _onPublishResult(result);
      }
    } else {
      if (_onUnpublishResult != null) {
        _onUnpublishResult(result);
      }
    }
  }

  @override
  Future<void> onRemoteUserOnLineNotify(String uid) async {
    if (_onRemoteUserOnLineNotify != null) {
      _onRemoteUserOnLineNotify(uid);
    }
  }

  @override
  Future<void> onRemoteUserOffLineNotify(String uid) async{
    if (_onRemoteUserOffLineNotify != null) {
      _onRemoteUserOffLineNotify(uid);
    }
  }
}

mixin _Callbacks {
  void Function(String uid) _onRemoteUserOffLineNotify;
  void Function(String uid) _onRemoteUserOnLineNotify;
  void Function(int result /*, String publishId */) _onPublishResult;
  void Function(int result) _onUnpublishResult;
}
