part of ali_rtc_fluttify;

/// AliRtcRenderMode提供四种渲染模式。
/// （推荐）AliRtcRenderModeAuto：自动模式。
/// AliRtcRenderModeStretch：拉伸填充视图，不保持视频比例。
/// AliRtcRenderModeFill：在保持视频宽高比的同时缩放，填充黑边。
/// AliRtcRenderModeCrop：在保持视频宽高比的同时缩放，并裁剪以适合视图。
enum RenderMode {
  Auto,
  Stretch,
  Fill,
  Clip,
}

/// AliRtcRenderMirrorMode在本地或远端均可设置镜像模式，并提供三种镜像模式。
/// AliRtcRenderMirrorModeOnlyFrontCameraPreviewEnabled：只有前置摄像头预览镜像，其余不镜像。
/// AliRtcRenderMirrorModeAllEnabled：全部镜像。
/// AliRtcRenderMirrorModeAllDisabled：全部不镜像。
enum MirrorMode {
  OnlyFront,
  AllEnabled,
  AllDisable,
}

enum Track {
  TrackNo,
  TrackCamera,
  TrackScreen,
  TrackBoth,
}
